CME(1p)

NAME
cme - Check or edit configuration data with Config::Model

VERSION
version 1.044

SYNOPSIS
  # general synopsis
  cme [ global_options ] command application [ options ] [ file ] [ modification_instructions ]

  # edit dpkg config with GUI (and Config::Model::Dpkg)
  cme edit dpkg

  # read data from arbitrary file (for model read from alternate file)
  cme check dpkg-copyright -file path/to/file

  # edit /etc/sshd_config (with Config::Model::OpenSsh)
  sudo cme edit sshd

  # edit ~/.ssh/config (with Config::Model::OpenSsh)
  cme edit ssh

  # check validity
  cme check dpkg

  # check dpkg files, update deprecated parameters and save
  cme migrate dpkg

  # like migrate, but also apply all suggested fixes
  cme fix dpkg

  # modify configuration with command line
  cme modify dpkg source 'format="(3.0) quilt"'

  # likewise with an application that accepts file override
  cme modify dpkg-copyright 'Comment="Modified with cme"'

  # map conf data to a fuse file system
  cme fusefs dpkg-copyright -d fuse_dir
  $ ls -l fuse_dir/License/LGPL-2.1+/text
  -rw-r--r-- 1 domi domi 391 30 Jan 19:00 fuse_dir/License/LGPL-2.1+/text
  $ fusermount -u fuse_dir

  # list all available applications (depends on your installation)
  cme list

DESCRIPTION
Depending on the command described below, "cme" program will use Config::Model configuration descriptions to check or modify or fix configuration files.

The 3rd parameter specify the application you want to work on. Most of the time, the relevant configuration file(s) will be found by cme. This is the most simple case. For instance:

  sudo cme check popcon

Some application like the late "multistrap" have no constraint on the configuration file name and will require you to specify your configuration file name:

  cme check multistrap raspbian.conf

or

  cme check multistrap -file raspbian.conf

Configuration file specification
The configuration of an application can take different forms. Either several files (like debian packages), a single file with a predefined file (popcon), or a single file with an arbitrary file name (like the late multistrap).

When needed the configuration file name is specified as the 3rd command argument, i.e. "cme command application file_name". This applies if the application requires a configuration file name to edit, or if the application allows configuration file override.

Main commands
This section describes the main commands shipped with cme. Other Config::Model extensions can bring more command. Run "cme help" to get the list of available commands on your system.

  list
Show a list all applications where a model is available. This list depends on installed Config::Model modules.

  edit
Edit a configuration. By default, a Tk GUI will be opened If Config::Model::TkUI is installed. See App::Cme::Command::edit.

  shell
Edit the configuration with a shell like interface. See App::Cme::Command::shell.

  check
Checks the content of the configuration file of an application. See App::Cme::Command::check.

  migrate
Update deprecated parameters (old value are saved to new parameters) and save the new configuration. See App::Cme::Command::migrate.

  fix
Migrate data and fix warnings. See App::Cme::Command::fix.

  modify
Modify a configuration file with the values passed on the command line. See App::Cme::Command::modify.

  update
Update the content of the configuration file from external data. Currently, only dpkg-copyright model support update sub command. See App::Cme::Command::update.

  search
Search configuration data for a specific string. See App::Cme::Command::search.

  fusefs
Map the configuration file content to a FUSE virtual file system on a directory specified with option "-fuse-dir". Modifications done in the fuse file system are saved to the configuration file when the "fusermount -u" is run.

Global options
The following options are available for all commands:

-create
    Perform the operation even if the configuration file is missing. This may be used to create a minimal configuration file. This option is disabled by default as a missing configuration file often indicates an error during the installation of the application.

-file
    For model that support it, specify an alternate file to read and write the configuration.

    You can use this option for model that require the target file to be specified (e.g. the late multitrap model). A file can also be specified with the 4th command argument. E.g. these 2 commands have the same effect:

      cme check multistrap foo.conf
      cme check multistrap -file foo.conf

-force-load
    Load file even if errors are found in data. Bad data is discarded

-canonical
    Write config data back using model order. By default, write items back using the order found in the configuration file. This feature is experimental and not supported by all backends.

-backup
    Create a backup of configuration files before saving. By default, "old" will be appended to the backup file. I.e. "foo.conf" will be backed up as "foo.conf.old". You can specify an alternate suffix. For instance "-backup dpkg-old".

-save
    Force a save even if no change was done. Useful to reformat the configuration file.

-strict
    When set, cme will exit 1 if warnings are found during check (of left after fix)

-verbose
    Show more information about what's going on.

-quiet
    Suppress all output except error messages.

Advanced options

-model-dir
    Specify an alternate directory to find model files. Mostly useful for tests.

-root-dir
    Specify a pseudo root directory to read and write the configuration files. (Actual default directory and file names depends on the model (See "-model" option). For instance, if you specify "~/mytest", the "/etc/ssh/sshd_config" files will be written in "~/mytest/etc/ssh/" directory.

-stack-trace
    Provides a full stack trace when exiting on error.

-try-app-as-model
    When set, try to load a model using directly the application name specified as 3rd parameter on the command line. Experimental.

Embedding cme
You can use cme from another program by using "-ui simple" option. This way you will be able to send command on the standard input of "cme" and get the results from the standard output.

Logging
All Config::Model logging is now based on Log::Log4perl. Logging can be configured in the following files:

•

     ~/.log4config-model

•

     /etc/log4config-model.conf

A sample of a ".log4config-model" is provided in contrib directory in "Config::Model" distribution of on github <https://github.com/dod38fr/config-model/blob/master/contrib/log4config-model>

Without these files, the following Log4perl config is used:

 log4perl.rootLogger=WARN, Screen
 log4perl.logger.Model.Legacy = INFO, SimpleScreen
 log4perl.additivity.Model.Legacy = 0

 log4perl.appender.Screen        = Log::Log4perl::Appender::Screen
 log4perl.appender.Screen.stderr = 0
 log4perl.appender.Screen.layout = Log::Log4perl::Layout::PatternLayout
 log4perl.appender.Screen.layout.ConversionPattern = %M %m (line %L)%n

 log4perl.appender.SimpleScreen        = Log::Log4perl::Appender::Screen
 log4perl.appender.SimpleScreen.stderr = 0
 log4perl.appender.SimpleScreen.layout = Log::Log4perl::Layout::PatternLayout
 log4perl.appender.SimpleScreen.layout.ConversionPattern = %p: %m%n

 log4perl.oneMessagePerAppender = 1

Log4perl uses the following categories:

Anything
Anything::Change
    Trace change notification through configuration tree and instance.

Backend
Backend::Debian::Dpkg
Backend::Debian::Dpkg::Control
Backend::Debian::Dpkg::Copyright
Backend::Fstab
Backend::IniFile
Backend::PlainFile
Backend::ShellVar
Backend::Yaml
FuseUI
Instance
Loader
Model::Searcher
Tree::Element::CheckList
Tree::Element::Id
Tree::Element::Id::Hash
Tree::Element::Id::List
Tree::Element::Value
Tree::Element::Value::Dependency
Tree::Node
Tree::Node::Warped
ValueComputer
Warper
Iterator
Model

More categories will come.

EXIT CODE
cme exits 0 when no errors are found. Exit 1 otherwise.

BUGS

  Files may be re-ordered
"cme" imposes a specific ordering of the parameters of a configuration file. This ordering is derived from the documentation of the configuration, like ssh_confg. "cme" writes back files using this ordering.

Thus, the diff between the original configuration files and the new version of the file may be more important than expected when "cme" is used the first time.

  Comments may be dropped
Comments are not supported in some applidations (like the one that use YAML in configuration files). Comments are dropped when using "cme" to edit or modify such files. For more details, see Available backend <https://github.com/dod38fr/config-model/wiki/Available-models-and-backends#Available_backend> page.

  Configuration models can lag behind the target application
If a configuration model is not up-to-date, you will get errors complaining about unknown parameters. In such a case, please file a bug on github <https://github.com/dod38fr/cme-perl/issues> or fix the model and send a pull request. You can see this example from OpenSsh <https://github.com/dod38fr/config-model/wiki/New-parameter-for-openssh-example> to learn how to fix a model.

FOR MORE INFORMATION
For more information, please check:

•   config-model wiki: <http://github.com/dod38fr/config-model/wiki>

•   Blogs about this project: <https://ddumont.wordpress.com/category/perl/configmodel/>

CONTRIBUTORS
In alphabetical order:

 Ross Vandegrift

FEEDBACKS
Feedback from users are highly desired. If you find this module useful, please share your use cases, success stories with the author.

SEE ALSO
Config::Model::Model, Config::Model::Instance, Config::Model::Node, Config::Model::HashId, Config::Model::ListId, Config::Model::WarpedNode, Config::Model::Value

AUTHOR
Dominique Dumont

COPYRIGHT AND LICENSE
This software is Copyright (c) 2014-2022 by Dominique Dumont <ddumont@cpan.org>.

This is free software, licensed under:

  The GNU Lesser General Public License, Version 2.1, February 1999